import React from 'react';

import type { GeneralSizeProp } from '@/mui/types';

import { isEvergreenFeedSelector } from '@/modules/feeds/Editor/redux/selectors';
import { setAction } from '@/modules/feeds/Editor/redux/slices';

import { useFormSettings } from '@/modules/@common/Form';
import { useAppDispatch, useAppSelector } from '@/modules/@common/store/hooks';
import { Switch } from '@/mui/components';

type PropTypes = {
  disabled?: boolean;
};

function Evergreen({ disabled = false }: PropTypes) {
  const dispatch = useAppDispatch();
  const { size } = useFormSettings();

  const isEvergreenFeed = useAppSelector(isEvergreenFeedSelector);

  return (
    <Switch
      data-id="isEvergreenFeed"
      size={size as GeneralSizeProp}
      color="primary"
      checked={isEvergreenFeed}
      disabled={disabled}
      onChange={(e) => dispatch(setAction({ isEvergreenFeed: e.target.checked }))}
    />
  );
}

export default Evergreen;
